unit Unit1; 

{$mode objfpc}{$H+}

interface

uses
  Classes, SysUtils, FileUtil, Forms, Controls, Graphics, Dialogs, ExtCtrls,
  StdCtrls, ComCtrls, Buttons, Crt, (*Beachte KeyPreview im Formular*)
  Process;

type

  { TFormsimpleGUIsnap }

  TFormsimpleGUIsnap = class(TForm)
    BitBtnStart: TBitBtn;
    ButtonInternet: TButton;
    ButtonList: TButton;
    ButtonAbbruch: TButton;
    ButtonChanges: TButton;
    ButtonLoeschen: TButton;
    ButtonPlatz: TButton;
    ButtonPlatzGesamt: TButton;
    ButtonRefresh: TButton;
    EditInstall: TEdit;
    EditRemove: TEdit;
    EditBefehl: TEdit;
    EditFind: TEdit;
    EditRemoveNummer: TEdit;
    LabelBefehl: TLabel;
    MemoAnleitung: TMemo;
    PanelComputer: TPanel;
    Process: TProcess;
    StatusBar: TStatusBar;
    procedure BitBtnStartClick(Sender: TObject);
    procedure ButtonAbbruchClick(Sender: TObject);
    procedure ButtonChangesClick(Sender: TObject);
    procedure ButtonInternetClick(Sender: TObject);
    procedure ButtonListClick(Sender: TObject);
    procedure ButtonLoeschenClick(Sender: TObject);
    procedure ButtonPlatzClick(Sender: TObject);
    procedure ButtonPlatzGesamtClick(Sender: TObject);
    procedure ButtonRefreshClick(Sender: TObject);
    procedure EditInstallChange(Sender: TObject);
    procedure EditRemoveChange(Sender: TObject);
    procedure EditFindChange(Sender: TObject);
    procedure EditRefreshChange(Sender: TObject);
    procedure EditRemoveNummerChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);

  private
    { private declarations }
  public
    { public declarations }
  end; 

var
  FormsimpleGUIsnap: TFormsimpleGUIsnap;

  TextDatei:                   TextFile;
  TextZeile:                   string;

const
  Apostroph=#39;

implementation

{$R *.lfm}

{ TFormsimpleGUIsnap }

(*--------------------------- StartBedingungen -------------------------------*)

procedure TFormsimpleGUIsnap.FormCreate(Sender: TObject);

begin
  AssignFile(TextDatei,'/tmp/simpleGUIsnap.sh');                                // /tmp
  Try                                                                           // Anlegen Skript für Rechte einstellen
    Rewrite(TextDatei);                                                         // hier günstig, da Rechte bei Rewrite erhalten bleiben!
    Except
      ShowMessage('Skript simpleGUIsnap.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
      Halt;
  end;

  TextZeile:='#!/bin/bash';
  WriteLN(Textdatei,TextZeile);
  CloseFile(TextDatei);

  Process.CommandLine:='chmod 777 /tmp/simpleGUIsnap.sh';                       // Recht einstellen /tmp
  Process.Active:=true;                                                         // eigentlicher Aufruf

  StatusBar.Panels[0].Text:='Programm simpleGUIsnap gestartet. Die Voreinstellungen sind optimal!';
end;

(*--------------------------- inastall ---------------------------------------*)

procedure TFormsimpleGUIsnap.EditInstallChange(Sender: TObject);
begin
//  ShowMessage('Befehl Install');
  EditBefehl.Text:=EditInstall.Text;
  StatusBar.Panels[0].Text:='Befehl "'+EditInstall.Caption+'" gewählt.';
end;

(*--------------------------- remove -----------------------------------------*)

procedure TFormsimpleGUIsnap.EditRemoveChange(Sender: TObject);
begin
  EditBefehl.Text:=EditRemove.Text;
  StatusBar.Panels[0].Text:='Befehl "'+EditRemove.Caption+'" gewählt.';
end;

(*--------------------------- find -------------------------------------------*)

procedure TFormsimpleGUIsnap.EditFindChange(Sender: TObject);
begin
  EditBefehl.Text:=EditFind.Text;
  StatusBar.Panels[0].Text:='Befehl "'+EditFind.Caption+'" gewählt.';
end;

(*--------------------------- refresh ---------------------------------------*)

procedure TFormsimpleGUIsnap.EditRefreshChange(Sender: TObject);
begin
  EditBefehl.Text:=ButtonRefresh.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+ButtonRefresh.Caption+'" gewählt.';
end;

(*--------------------------- remove nr. -------------------------------------*)

procedure TFormsimpleGUIsnap.EditRemoveNummerChange(Sender: TObject);
begin
  EditBefehl.Text:=EditRemoveNummer.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+EditRemoveNummer.Caption+'" gewählt.';
end;

(*--------------------------- list -------------------------------------------*)

procedure TFormsimpleGUIsnap.ButtonListClick(Sender: TObject);
begin
  EditBefehl.Text:=ButtonList.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+ButtonList.Caption+'" gewählt.';
end;

(*--------------------------- Loeschen ---------------------------------------*)

procedure TFormsimpleGUIsnap.ButtonLoeschenClick(Sender: TObject);
begin
  EditBefehl.Text:=ButtonLoeschen.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+ButtonLoeschen.Caption+'" gewählt.';
end;

(*--------------------------- Platzbedarf ------------------------------------*)

procedure TFormsimpleGUIsnap.ButtonPlatzClick(Sender: TObject);
begin
  EditBefehl.Text:=ButtonPlatz.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+ButtonPlatz.Caption+'" gewählt.';
end;

(*--------------------------- Platzbedarf gesamt -----------------------------*)

procedure TFormsimpleGUIsnap.ButtonPlatzGesamtClick(Sender: TObject);
begin
  EditBefehl.Text:=ButtonPlatzGesamt.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+ButtonPlatzGesamt.Caption+'" gewählt.';
end;

(*--------------------------- refresh ----------------------------------------*)

procedure TFormsimpleGUIsnap.ButtonRefreshClick(Sender: TObject);
begin
  EditBefehl.Text:=ButtonRefresh.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+ButtonRefresh.Caption+'" gewählt.';
end;

(*--------------------------- changes ----------------------------------------*)

procedure TFormsimpleGUIsnap.ButtonChangesClick(Sender: TObject);
begin
  EditBefehl.Text:=ButtonChanges.Caption;
  StatusBar.Panels[0].Text:='Befehl "'+ButtonChanges.Caption+'" gewählt.';
end;

(*--------------------------- Internet ---------------------------------------*)

procedure TFormsimpleGUIsnap.ButtonInternetClick(Sender: TObject);

var AProcess: TProcess;

begin
  EditBefehl.Text := '/usr/bin/firefox https://snapcraft.io/store';
  StatusBar.Panels[0].Text:='Befehl "'+ButtonInternet.Caption+'" gewählt.';

//  BitBtnStart.enabled:=false;                                                   // ist kein Befehl

//  AProcess := TProcess.Create(nil);
//  AProcess.CommandLine := '/usr/bin/firefox https://snapcraft.io/store';
//  AProcess.Options := AProcess.Options + [poWaitOnExit];                        // Möglichkeit, dass Programm soll nicht weiterläuft
//  AProcess.Execute;                                                             // eigentlicher Aufruf

//  AProcess.Free;
end;

(*--------------------------- Aktualisierung ---------------------------------*)

procedure TFormsimpleGUIsnap.BitBtnStartClick(Sender: TObject);
begin
  If EditBefehl.Text = '' Then
    Begin
      MessageDlg('Fehler: Kein Befehl eingegeben!',mtInformation,[mbOK],0);
      FormCreate(Sender);
    end                   Else
  Begin
    Try                                                                         // Anlegen Skript
      Rewrite(TextDatei);
      Except
        ShowMessage('Skript simpleGUIsnap.sh kann nicht anlegen werden! Bitte Verzeichnisse und Rechte prüfen!');
        Halt;
    end;

    TextZeile:='#!/bin/bash';
    WriteLN(TextDatei,TextZeile);
    TextZeile:='# 03.10.2014 - Freiheit   ><>';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Start Skript simpleGUIsnap.sh - Bitte haben Sie etwas Geduld!';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Befehl: '+EditBefehl.Text;
//    ShowMessage('Befehl: '+EditBefehl.Text);
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);

    TextZeile:=EditBefehl.Text;
    WriteLN(Textdatei,TextZeile);

    TextZeile:='echo';
    WriteLN(Textdatei,TextZeile);
    TextZeile:='echo Ende Skript simpleGUIsnap.sh - Danke für die Benutzung!';
    WriteLN(Textdatei,TextZeile);

    CloseFile(TextDatei);
    ButtonAbbruch.Enabled := true;
//    ShowMessage('Haltepunkt nach Rewrite einstellen');
    Process.CommandLine:='xterm -hold -sb -right -geometry 180x50 -e /tmp/./simpleGUIsnap.sh';
    Process.Active:=true;                                                       // eigentlicher Aufruf

    StatusBar.Panels[0].Text:='Befehl gestartet. Gedrückte Maustaste im Terminal-Fenster hält Befehl an! Click auf x im Terminal-Fenster beendet Befehl!   ><>';
  end;
end;

(*--------------------------- Abbruch ----------------------------------------*)

procedure TFormsimpleGUIsnap.ButtonAbbruchClick(Sender: TObject);
begin
  Process.Active:=false; BitBtnStart.enabled:=true;
  ButtonAbbruch.Enabled:=false;
  StatusBar.Panels[0].Text:='Ende / Abbruch angefordert.';
end;

end.

